﻿/**
 * 
 * ボタンクリックで画像の読み込みとテキストを表示させる
 * 2010/07/24
 * 
 */


/**
 * 画像のURL、テキストの定義
 */
var _photos:Array = ["img/designer.jpg", "img/engineer.jpg", "img/manager.jpg", "img/accounting.jpg"];
var _txt0:String = "A designer is a person whose work uses the design process. This means that a designer could be everyone who will use drafts, sketches to aid in the creation of a work, a product, an equipment of any scale. "
var _txt1:String = "An engineer is a professional practitioner of engineering, concerned with applying scientific knowledge, mathematics and ingenuity to develop solutions for technical problems."
var _txt2:String = "Management in all business areas and organizational activities are the acts of getting people together to accomplish desired goals and objectives."
var _txt3:String = "Accounting is defined by the American Institute of Certified Public Accountants (AICPA) as 'the art of recording, classifying, and summarizing in a significant manner and in terms of money, transactions and events which are, in part at least, of financial character, and interpreting the results thereof.'";
var _texts:Array = [ _txt0, _txt1, _txt2, _txt3];

/**
 * その他の変数の定義
 */
var _items:Array = [ menu0, menu1, menu2, menu3];
var _description_txt:TextField = description_txt;
var _temp:MovieClip;
var _box:MovieClip = this.createEmptyMovieClip("box", 1);
_box._x = 201;
_box._y = 116;
_description_txt.text = "";

/**
 * メニューの処理
 */
for (var i:Number = 0; i < _items.length; i++) {
	
	//配列からボタンを取得し、一度変数に代入
	var item:MovieClip = _items[i];
	
	//ボタンの初期状態を変更
	item.over._alpha = 0;
	item.caption._alpha = 0;
	item.txt.gotoAndStop(i + 1);
	item.txt._x = 23 - 10;
	
	//ボタンそれぞれにIDを定義する
	item.id = i;
	
	//ボタンの動作を定義
	item.onRollOver = rollOver;
	item.onRollOut = rollOut;
	item.onRelease = release;
}

/**
 * ボタンイベントの処理
 */
function rollOver():Void{
	alphaTo(this.over, 100, 4);
	alphaTo(this.caption, 100, 4);
	moveTo(this.txt, 23, 3);
}

function rollOut():Void{
	if(this!=_temp){
		alphaTo(this.over, 0, 12);
		alphaTo(this.caption, 0, 2);
		moveTo(this.txt, 23-10, 4);
	}
}

function release():Void {
	//クリックしたメニューを固定する処理
	if (_temp != null) {
		alphaTo(_temp.over, 0, 12);
		alphaTo(_temp.caption, 0, 2);
		moveTo(_temp.txt, 10, 4);
		_temp.enabled = true;
	}
	_temp = this;
	this.enabled = false;
	
	//画像読み込み
	loadPhoto(_photos[this.id]);
	
	//テキスト表示
	textInsert(_description_txt, _texts[this.id]);
}

/**
 * モーション用関数
 */
function alphaTo(mc:MovieClip, a:Number, r:Number ):Void {
	var temp:Number;
	mc.onEnterFrame = function():Void {
		this._alpha += (a - this._alpha) / r;		
		if ( Math.abs(this._alpha - temp) < 0.01) {
			delete this.onEnterFrame;
		}
		temp = this._alpha;
	}
}

function moveTo(mc:MovieClip, a:Number, r:Number ):Void {
	var temp:Number;
	mc.onEnterFrame = function():Void {
		this._x += (a - this._x) / r;	
		if ( Math.abs(this._x - temp) < 0.01) {
			delete this.onEnterFrame;
		}
		temp = this._x;
	}
}

function textInsert(tf:TextField,str:String):Void {
	var items:Array = str.split("");
	var temp:String = "";
	var cc:Number = 0;
	this.onEnterFrame = function():Void {
		temp += items[cc];
		tf.text = temp;
		if (++cc>items.length-1) {
			delete this.onEnterFrame;
		}
	}
}

/**
 * 画像の読み込み
 */
function loadPhoto(url:String):Void {
	var loader:MovieClipLoader = new MovieClipLoader();
	var target:MovieClip = _box;
	var listener:Object = {};
	listener.onLoadStart = function(mc:MovieClip) {
		// ロード開始時の処理
	};
	listener.onLoadError = function(mc:MovieClip, error:String, status:Number) {
		// ロードできなかったときの処理
	};
	listener.onLoadProgress = function(mc:MovieClip, loaded:Number, total:Number) {
		// ロード中の処理
		var percent:Number = loaded / total;
	};
	listener.onLoadComplete = function(mc:MovieClip) {
		// ロード完了時の処理
	};
	listener.onLoadInit = function(mc:MovieClip) {
		// ロードしたSWFの第1フレームアクション実行後の処理
		mc._alpha = 0;
		alphaTo(mc, 100, 10);
	};
	loader.addListener(listener);
	loader.loadClip( url, target );
	
	/*
	MovieClipLoaderについての参考資料
	http://www.fumiononaka.com/TechNotes/Flash/FN0501003.html
	http://un-q.net/2006/10/onloadcompleteonloadinit.html
	*/
}
